background = Image.load("bg.png")
lowe = Sound.load("lowe.wav",false)
astring = Sound.load("a.wav",false)
dstring = Sound.load("d.wav",false)
gstring = Sound.load("g.wav",false)
bstring = Sound.load("b.wav",false)
highe = Sound.load("highe.wav",false)

function textreader(filename)
	text = {}

	file = io.open(filename,"r")

	screen:clear(Color.new(0, 0, 0))

	i=1
	start=0
	startx=0
	cross=0
	mode1=0
	mode2=0

	line=file:read("*l")

	while line~=nil do
		text[i]=line
		i=i+1
		line=file:read("*l")
	end

	exit2=false

	if i>34 then
		k=34
	else
		k=i
	end

	while exit2==false do
		pad = Controls.read()
		if pad:select() then
			exit2=true
		end
		if pad:cross() then
			cross=10
		elseif pad:circle() then
			cross=100
		else
			cross=1
		end

		if pad:down() then
				start=start+cross
				if i<k+start then
					start=i-k
				end
		elseif pad:up() then
				start=start-cross
				if start<0 then
					start=0
				end
		end

		if pad:right() then
				startx=startx+cross
		elseif pad:left() then
				startx=startx-cross
				if startx<0 then
					startx=0
				end
		end

		if pad:l() then
			if mode1==0 then
				mode1=1
			else
				mode1=0
			end
		end

		if pad:r() then
			if mode2==0 then
				mode2=1
			else
				mode2=0
			end
		end

		screen:clear(Color.new(0, 0, 0))

		for j = 1,k-1 do
			if mode2==0 then
				screen:print(0, 8*(j-1), string.format("%s",string.sub(text[j+start],startx,(string.len(text[j+start])-mode1))), Color.new(255, 255, 255))
			else
				screen:print(0, 8*(j-1), string.format("%04d",j+start), Color.new(0, 192, 0))
				screen:print(36, 8*(j-1), string.format("%s",string.sub(text[j+start],startx,(string.len(text[j+start])-mode1))), Color.new(255, 255, 255))
			end
		end

		screen.waitVblankStart()
		screen.flip()
		screen.waitVblankStart(3)

	end
end

function tabview()
screen:clear()
screen.waitVblankStart()
screen.flip()
--screen.waitVblankStart(120)
System.currentDirectory("ms0:/")
newcwd = System.currentDirectory("ms0:/")

select=1
scroll=0

dir = {}

dir = System.listDirectory(newcwd)

exit=false
exit2=false

while true do
	pad = Controls.read()
	if pad:start() then
		exit=true
	end
	if pad:up() then
		if select < 2 then
			select = 1
		else
			select=select-1
		end
		if (scroll > 0 and select <= scroll) then
			scroll = scroll-1
		end
	elseif pad:down() then
		if select > table.getn(dir)-1 then
			select = table.getn(dir)
		else
			select=select+1
		end
		if (select > 34) and (scroll < table.getn(dir)-34) then
			scroll = scroll+1
		end
	elseif pad:triangle() then
		if newcwd~="ms0:/" then
			newcwd=string.gsub(newcwd, "/[%w%%]-/$", "/")
			select=1
			dir = System.listDirectory(newcwd)
		end
	elseif pad:cross() then
		if dir[select].name=="." then
		elseif dir[select].directory==false then
			ext4 = string.lower(string.sub(dir[select].name, -5))
			ext3 = string.lower(string.sub(dir[select].name, -4))
			ext2 = string.lower(string.sub(dir[select].name, -3))
			ext1 = string.lower(string.sub(dir[select].name, -2))
			if ext4==".html" or ext3==".htm" or ext3==".php" or ext3==".asp"  or ext4==".aspx" or ext3==".txt" or ext3==".ini" or ext3==".lua" or ext3==".cpp" or ext3==".hpp" or ext3==".cxx" or ext3==".hxx" or ext1==".c" or ext1==".h" or ext4==".java" or ext2==".js" or ext2==".vb" or ext3==".vbs" or ext3==".asm" or ext3==".bat" then
				System.currentDirectory(newcwd)
				textreader(dir[select].name)
			end
		elseif dir[select].name==".." then
			newcwd=string.gsub(newcwd, "/[%w%%]-/$", "/")
			select=1
			dir = System.listDirectory(newcwd)
		else
			newcwd=string.format("%s%s/",newcwd,dir[select].name)
			select=1
			dir = System.listDirectory(newcwd)
		end
	end

	screen:clear(Color.new(0, 0, 0))

	for i=1,table.getn(dir) do
		if i==select then
			textcolor=Color.new(0, 196, 0)
		else
			textcolor=Color.new(255, 255, 255)
		end

		if dir[i].directory then
			screen:print(0, 8*(i-1-scroll), dir[i].name.." <dir>", textcolor)
		else
			screen:print(0, 8*(i-1-scroll), dir[i].name, textcolor)
		end
	end

	screen.waitVblankStart()
	screen.flip()
	screen.waitVblankStart(3)

end

end

function controls()
	pad = Controls.read()
	if pad:cross() then
		lowe:play()
	end
	if pad:circle() then
		astring:play()
	end
	if pad:triangle() then
		dstring:play()
	end
	if pad:square() then
		gstring:play()
	end
	if pad:l() then
		bstring:play()
	end
	if pad:r() then
		highe:play()
	end
	if pad:select() then
		tabview()
	end
end

screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false)
screen.waitVblankStart()
screen.flip()
SoundSystem.SFXVolume(128) -- max 
SoundSystem.reverb(1) -- out of 15 
SoundSystem.panoramicSeparation(0)

while true do
	controls()
	screen.waitVblankStart()
end